VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FileRepoWriter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Public Header As FileHeader
Public Fo As Footer
Public Page As FileRepoPage
Dim Ffile As CoMFileRepo
Dim Ffilename As String
Dim FGenerating As Boolean
Dim CurrentPageOffset As Long
Dim CurrentPageSize As Long
Dim CurrentPageEntry As Long
Dim currentpage As Integer

Private Sub Class_Initialize()
   Set Header = New FileHeader
   Set Page = New FileRepoPage
   Set Fo = New Footer
   Set Ffile = New CoMFileRepo
   FGenerating = False
   CurrentPageOffset = 0
   CurrentPageSize = 0
   CurrentPageEntry = 0
   currentpage = 0
End Sub

Private Sub Class_Terminate()
   Set Header = Nothing
   Set Fo = Nothing
   Set Page = Nothing
   Set Ffile = Nothing

End Sub

Public Sub RefreshPage()
    Page.Refresh
End Sub

Public Property Get Filename() As String
      Filename = Ffilename
End Property

Public Property Let Filename(ByVal vNewValue As String)
  If Not FGenerating Then
        Ffilename = vNewValue
  End If
End Property


Public Sub CreateFile()
    If Not FGenerating Then
        FGenerating = True
        Ffile.Filename = Ffilename
        Ffile.NewFile
        ' look in the delphi side
        Call Header.WritetoFile(Ffile)
        CurrentPageOffset = Ffile.Pos
        CurrentPageSize = 0
        CurrentPageEntry = 0
   End If
   
End Sub


Public Sub Fontname(Aname As String)
    Call Page.Fontname(Aname)
End Sub


Public Sub FontSize(Asize As Integer)
    Call Page.FontSize(Asize)
End Sub


Public Sub FontBold(Abool As Boolean)
    Call Page.FontBold(Abool)
End Sub


Public Sub FontItalic(Abool As Boolean)
    Call Page.FontItalic(Abool)
End Sub


Public Sub FontUnderline(Abool As Boolean)
    Call Page.FontUnderline(Abool)
End Sub

Public Sub SetColor(Acolor As Long)
    Call Page.SetColor(Acolor)
End Sub


Public Sub FillStyle(Astyle As Integer)
    Call Page.FillStyle(Astyle)
End Sub

Public Sub TextOut(arow, acol As Double, Atext As String)
    Call Page.TextOut(arow, acol, Atext)
End Sub

Public Sub Lineto(arow As Double, acol As Double)
    Call Page.Lineto(arow, acol)
End Sub
Public Sub Moveto(arow As Double, acol As Double)
    Call Page.Moveto(arow, acol)
End Sub

Public Sub Rect(At, Al, Ab, Ar As Double)
    Call Page.Rect(At, Al, Ab, Ar)
End Sub

Public Sub SetPenWidth(awidth As Integer)
    Call Page.SetPenWidth(awidth)
End Sub

Public Sub NewPage()
    CurrentPageEntry = Page.EntryCount
    CurrentPageSize = Ffile.Pos - CurrentPageOffset
    Call Page.WritetoFile(Ffile)
    Call Fo.AddFooterEntry(CurrentPageOffset, CurrentPageSize, CurrentPageEntry)
    Page.Refresh
    CurrentPageOffset = Ffile.Pos
    CurrentPageSize = 0
    CurrentPageEntry = 0
End Sub


Public Sub LastPage()
    CurrentPageEntry = Page.EntryCount
    CurrentPageSize = Ffile.Pos - CurrentPageOffset
    Call Page.WritetoFile(Ffile)
    Call Fo.AddFooterEntry(CurrentPageOffset, CurrentPageSize, CurrentPageEntry)
    Page.Refresh
    Header.FooterOffset = Ffile.Pos
    Header.TotalPages = Fo.EntryCount
    Call Fo.WritetoFile(Ffile)
    Call Header.WritetoFile(Ffile)
    Ffile.Close
    
    FGenerating = False
End Sub




